	opt o+,ow-,a+

sop:
;
; this sample demonstrates how to hook into the SHOW chain
; this is actually a small portion of the DC SHOWARC module
; this sample code is placed into the PUBLIC DOMAIN.  Only this portion
; of sample code can be used.  Any code in the DC DESKTOP programs is
; Copyright (c) 1990 Double Click Software
;

start2:
    bra.w   start

; you must define an extender table which lists the extenders which you
; are able to handle.  Each entry must be 3 charaters long, and the entire
; table must be null terminated.

extender_table:
    dc.b    'ARC'
    dc.b    0
    even

; when you define the point where DC DESKTOP will JSR (jump subroutine) to
; you must have a HEADER which looks like the following immediately before
; the point to JSR to:
;
; my_name:
;   dc.b    14      ; always null terminated, and always 14 bytes
; extender_ptr:
;   dc.l    extender_table  ; this is a pointer to your externder table
; old_show:
;   dc.l    0       ; this is the old show subroutine that was in place
                    ; before you installed yours.  Should you be unable
                    ; to handle the given file, you would then check to
                    ; see if this is zero (and if so, RTS), and if not
                    ; you would need to JMP to the old routine, making sure
                    ; to RESTORE A0 and D0 before you do.
; cookie:
;   dc.w    $dcdc   ; this magic word must be present.  DC DESKTOP verifies
                    ; that the module is valid by checking for this value


my_name:
    dc.b    'DCSHOARC.PRG',0,0
extender_ptr:
    dc.l    extender_table
old_show:
    dc.l    0
cookie:
    dc.w    $dcdc

;
; on entry to your routine, D0 and A0 contain:
; d0 = file handle - the file selected is already open, the file pointer
                    ; is positioned at the first byte, and you are ready to
                    ; read or manipulate the file as desired.  You should
                    ; not close the file when yuo return
; a0 = pointer to the filename - this is the pointer to the filename which
                    ; is being SHOWn.  This is not usually the complete path,
                    ; but just the filename.  If this file is shown from the
                    ; CABINET, then the pointer will point to the complete
                    ; pathname.


showarc:
    move.w  d0,handle   ; save file handle
    move.l  a0,arc_name ; save file name pointer
.loop:
    tst.b   (a0)+       ; go to end of name
    bne.s   .loop
    subq    #4,a0       ; point to 'A' hopefully
    cmp.b   #'A',(a0)+  ; is it an .ARC file? - 'A'?
    bne.s   .not_ours   ; nope
    cmp.b   #'R',(a0)+  ; 'R'?
    bne.s   .not_ours   ; nope
    cmp.b   #'C',(a0)+  ; 'C'?
    beq.s   arc_crc     ; bingo!
.not_ours:
    move.l  arc_name,a0 ; restore A0 - if D0 damaged, restore it too!
    move.l  old_show,a1 ; is someone else installed? Returned from call below
    cmp.l   #0,a1       ; zero, no one here
    beq.s   .jump_back  ; no one home, return so OS can handle it
    jmp     (a1)        ; someone else is installed, JMP (JuMP) to them
.jump_back:
    rts                 ; if we can't handle it, we MUST return with a non-
                        ; zero value in D0, here, the file handle is in D0


arc_crc:                ; your routine here
    move.l  #test_text,-(a7)    ; print a string
    move.w  #9,-(a7)
    trap    #1
    addq    #6,a7
    moveq   #0,d0       ; we handled it, move 0 into D0, otherwise non-zero
    rts


start:
    move.l  #mystack,a7
    move.l  $c(a3),d0       text len
    add.l   $14(a3),d0      data len
    add.l   $1c(a3),d0      BSS len
    add.l   #$100,d0        basepage
    move.l  d0,-(sp)
    move.l  a3,-(sp)
    clr.w   -(sp)
    move.w  #$4a,-(sp)
    trap    #1      shrink memory
    lea 12(sp),sp

    ; Setexc call to return vector $a4 (TRAP 9)
    move.l  #-1,-(a7)
    move.w  #$29,-(a7)
    move.w  #$5,-(a7)
    trap    #13
    addq    #8,a7
    move.l  d0,a0
    cmp.w   #$dc,-(a0)  ; is DC DESKTOP present? magic word?
    bne.s   no_go       ; nope


    pea     showarc     ; push routine to jump to
    move.w  #$dc00,-(a7); function $dc00 in DC DESKTOP, register new SHOW
    trap    #9          ; do it
    addq.l  #6,a7       ; fix stack

    move.l  d0,old_show ; old routine is returned to us

    pea     show_name   ; show we are here
    move.w  #9,-(a7)    ; Cconws
    trap    #1
    addq.l  #6,a7

    clr.w   -(a7)       ; Ptermres
    move.l  #eop,d0     ; end of program
    sub.l   #sop,d0     ; start of program
    add.l   #$100,d0    ; basepage size
    move.l  d0,-(a7)    ; Ptermres
    move.w  #$31,-(a7)
    trap    #1

no_go:
    pea     no_show_name
    move.w  #9,-(a7)
    trap    #1
    addq.l  #6,a7

    clr.w   -(a7)
    trap    #1


    DATA

test_text:
	dc.b	'AHA! An ARC file!',0
show_name:
    dc.b    'I am here!',0
no_show_name:
    dc.b    'I am NOT here!',0

    BSS:

handle:
	ds.w	1
arc_name:
	ds.l	1
	ds.l	$80
mystack:
eop:
